This is to introduce a new init script that can launch ntpclient
again after the hotplug invocation running with -l option to
adjust local time and clock shift continuously.
Please check, if this closes ticket 2292.
(see https://dev.openwrt.org/ticket/2292)
Signed-off-by: Steffen Hoffmann <hoff.st@shaas.net>
SVN-Revision: 10356
--- /dev/null
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2008 OpenWrt.org
+
+START=80
+
+config_cb() {
+ local cfg="$CONFIG_SECTION"
+ local cfgtype
+ config_get cfgtype "$cfg" TYPE
+
+ case "$cfgtype" in
+ ntpclient)
+ config_get hostname $cfg hostname
+ config_get port $cfg port
+
+ # prepare for continuos operation
+ count=0 # unlimited
+ ps | grep 'bin/[n]tpclient' >&- || {
+ while true; do
+ ping -c 1 $hostname 2>&- >&- && {
+ /usr/sbin/ntpclient -c ${count:-1} -l -h $hostname -p ${port:-123} 2>&- >&- &
+ } && return
+ sleep 3
+ done
+ }
+ ;;
+ esac
+}
+
+start() {
+ config_load ntpclient&
+}
+
+stop() {
+ killall ntpclient 2>&- >&-
+}